<?php

namespace Drupal\properties_field\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Provides a definition list formatter for the properties field.
 *
 * @FieldFormatter(
 *   id = "properties_list",
 *   label = @Translation("Properties list"),
 *   field_types = {
 *     "properties"
 *   }
 * )
 */
class PropertiesListFormatter extends PropertiesFormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [
      '#theme' => 'properties_list',
      '#items' => [],
    ];

    foreach ($items as $item) {
      $plugin = $this->getValueTypePlugin($item->type);
      $value = $plugin ? $plugin->formatterRender($item->value) : '';

      $elements['#items'][] = [
        'label' => $item->label,
        'value' => $value,
      ];
    }

    return $elements;
  }

}
